function [t]=tof3(CH2,SPW1,SPW2,f,tipo,umbral)

if tipo=='T'
a=load(strcat('CH2_Freq',num2str(f), 'MHz_CalibracionT_T1A_R1B_U2_Rep1.mat'));
b=load(strcat('CH2_Freq',num2str(f), 'MHz_CalibracionT_T1A_R1B_U2_Rep2.mat'));
c=load(strcat('CH2_Freq',num2str(f), 'MHz_CalibracionT_T1A_R1B_U2_Rep3.mat'));
elseif tipo=='L'
    a=load(strcat('CH2_Freq',num2str(f), 'MHz_CalibracionL_T1A_R1B_U2_Rep1.mat'));
b=load(strcat('CH2_Freq',num2str(f), 'MHz_CalibracionL_T1A_R1B_U2_Rep2.mat'));
c=load(strcat('CH2_Freq',num2str(f), 'MHz_CalibracionL_T1A_R1B_U2_Rep3.mat'));
else
    display('Variable tipo erronea')
end

E=mean([a.signalCH2;b.signalCH2;c.signalCH2]);

if tipo=='T'
    A2=max(CH2(SPW2:SPW2+1000));
    [pks2,lcs2]=findpeaks(-(CH2(SPW2:SPW2+2000)/max(abs(CH2(SPW2:SPW2+2000)))),'Npeaks',1,'MinPeakDistance',100,'MinPeakHeight',umbral);
    [pks1,lcs1]=findpeaks(-E(SPW1:SPW1+2000),'Npeaks',1,'MinPeakDistance',50,'MinPeakHeight',0.1);
    
    for ii=SPW2+lcs2:-1:1
       if abs(CH2(ii)/max(abs(CH2(SPW2:SPW2+2000))))<=0.1
           lcs2=ii;
           break;
       end
    end
    for ii=SPW1+lcs1:-1:1
       if abs(E(ii)/max(abs(E(SPW1:SPW1+2000))))<=0.01
           lcs1=ii;
           break;
       end
    end
       t=(lcs2-lcs1)/125e6;
elseif tipo=='L'
    A2=max(CH2(SPW2:SPW2+2000));
    [pks2,lcs2]=findpeaks(CH2(SPW2:SPW2+2000)/max(abs(CH2(SPW2:SPW2+2000))),'Npeaks',1,'MinPeakDistance',100,'MinPeakHeight',umbral);
    [pks1,lcs1]=findpeaks(E(SPW1:SPW1+2000),'Npeaks',1,'MinPeakDistance',100,'MinPeakHeight',0.05);

    for ii=SPW2+lcs2:-1:1
       if abs(CH2(ii)/max(abs(CH2(SPW2:SPW2+2000))))<=0.01
           lcs2=ii;
           break;
       end
    end

    for ii=SPW1+lcs1:-1:1
       if abs(E(ii)/max(abs(E(SPW1:SPW1+2000))))<=0.01
           lcs1=ii;
           break;
       end
    end

       t=(lcs2-lcs1)/125e6; 
end
