%% Resultados

material='C';


switch(material)
    case 'CG1'
        m=23.8e-3;
        V=2.0758e-05;
        rho=m/V;
        d11=2.897e-2;
        d22=2.905e-2;
        d33=2.904e-2;
        d12=3.034e-2;
        d13=3.035e-2;
        d23=3.048e-2;
    case 'CG2'
        m=23.9e-3;
        V=2.07e-5;
        rho=m/V;
        d11=2.897e-2;
        d22=2.905e-2;
        d33=2.905e-2;
        d12=3.035e-2;
        d13=3.037e-2;
        d23=3.043e-2;
    case 'SG1'
        m=24e-3;
        V=2.0758e-05;
        rho=m/V;
        d11=2.903e-2;
        d22=2.924e-2;
        d33=2.919e-2;
        d12=3.045e-2;
        d13=3.045e-2;
        d23=3.071e-2;
    case 'SG2'
        m=24e-3;
       V=2.0758e-05;
        rho=m/V;
        d11=2.901e-2;
        d22=2.926e-2;
        d33=2.923e-2;
        d12=3.044e-2;
        d13=3.044e-2;
        d23=3.057e-2;

    case 'C'
        m=24.5e-3;
        V=2.0758e-05;
        rho=m/V;
        d11=2.933e-2;
        d22=2.946e-2;
        d33=3.003e-2;
        d12=3.040e-2;
        d13=3.040e-2;
        d23=3.063e-2;
        
    case 'R'
        m=27.7e-3;
        V=2.0758e-05;
        rho=m/V;
        d11=2.943e-2;
        d22=2.937e-2;
        d33=2.986e-2;
        d12=3.057e-2;
        d13=3.071e-2;
        d23=3.065e-2;
        
    case 'W'
        m=24.7e-3;
        V=2.0758e-05;
        rho=m/V;
        d11=2.958e-2;
        d22=2.971e-2;
        d33=2.987e-2;
        d12=3.086e-2;
        d13=3.069e-2;
        d23=3.077e-2;
end


freq=[0.8:0.02:1.2];
configuracionT=["T1A_R1B_U2";"T1A_R1B_U3";"T2A_R2B_U3";"T23A_R23B_U1";"T13A_R13B_U2";"T12A_R12B_U3"];
configuracionL=["T1A_R1B_U2";"T2A_R2B_U3";"T3A_R3B_U2";"T23A_R23B_U1";"T13A_R13B_U2";"T12A_R12B_U3"];
t=zeros(12,21,3);
c=t;
C=zeros(9,21,3);
dt=[d11 d11 d22 d23 d13 d12];
dl=[d11 d22 d33 d23 d13 d12];
% 12 tiempos ->
% t11,t22,t33,t12,t13,t23,t12_12,t13_13,t23_23,t12_3,t13_2,t23_1
for ii=1:21
    for jj=1:6
        
        for mm=1:3
            %             cargaCH1=strcat('CH1_Freq', num2str(freq(ii)) ,'MHz_', material ,'_', configuracion(jj),'_','Rep',num2str(mm),'.mat');
            cargaCH2=strcat('CH2_Freq', num2str(freq(ii)) ,'MHz_', material ,'_', configuracionT(jj),'_','Rep',num2str(mm),'.mat');
            %             load(cargaCH1)
            signalCH2T=load(cargaCH2,'signalCH2');
            cargaCH2=strcat('CH2_Freq', num2str(freq(ii)) ,'MHz_', material ,'L_', configuracionL(jj),'_','Rep',num2str(mm),'.mat');
            signalCH2L=load(cargaCH2,'signalCH2');
            %             rt(ii,mm)=retardo(freq(ii),mm);
            [tt]=tof3(signalCH2T.signalCH2,10000,12500,freq(ii),'T',0.5);
            [tl]=tof3(signalCH2L.signalCH2,10000,10500,freq(ii),'L',0.2);
%             [tt]=tof2(signalCH2T.signalCH2,freq(ii),10000,12500,2000,'T');
%             [tl]=tof2(signalCH2L.signalCH2,freq(ii),10000,10500,2000,'L');
            %             tof3(CH2,SPW1,SPW2,f,tipo,umbral)
            if jj==1
                
                t(1,ii,mm)=tl;
                t(4,ii,mm)=tt;
                c(1,ii,mm)=dl(1)/t(1,ii,mm);
                c(4,ii,mm)=dt(1)/t(4,ii,mm);
            elseif jj==2
                t(2,ii,mm)=tl;
                c(2,ii,mm)=dl(2)/t(2,ii,mm);
                t(5,ii,mm)=tt;
                c(5,ii,mm)=dt(2)/t(5,ii,mm);
            elseif jj==3
                t(3,ii,mm)=tl;
                t(6,ii,mm)=tt;
                c(3,ii,mm)=dl(3)/t(3,ii,mm);
                c(6,ii,mm)=dt(3)/t(6,ii,mm);
            elseif jj==4
                t(9,ii,mm)=tl;
                c(9,ii,mm)=dl(4)/t(9,ii,mm);
                t(12,ii,mm)=tt;
                c(12,ii,mm)=dt(4)/t(12,ii,mm);
            elseif jj==5
                t(8,ii,mm)=tl;
                t(11,ii,mm)=tt;
                c(8,ii,mm)=dl(5)/t(8,ii,mm);
                c(11,ii,mm)=dt(5)/t(11,ii,mm);
            elseif jj==6
                t(7,ii,mm)=tl;
                t(10,ii,mm)=tt;
                c(7,ii,mm)=dl(6)/t(7,ii,mm);
                c(10,ii,mm)=dt(6)/t(10,ii,mm);
            end
        end
    end
end

C(1,:,1:3)=rho*c(1,:,1:3).^2;
C(2,:,1:3)=rho*c(2,:,1:3).^2;
C(3,:,1:3)=rho*c(3,:,1:3).^2;
C(4,:,1:3)=rho*c(6,:,1:3).^2;
C(5,:,1:3)=rho*c(5,:,1:3).^2;
C(6,:,1:3)=rho*c(4,:,1:3).^2;
C(7,:,1:3)=sqrt((C(1,:,1:3)+C(6,:,1:3)-2*rho*c(7,:,1:3).^2).*(C(2,:,1:3)+C(6,:,1:3)-2*rho*c(7,:,1:3).^2))-C(6,:,1:3);
C(8,:,1:3)=sqrt((C(1,:,1:3)+C(5,:,1:3)-2*rho*c(8,:,1:3).^2).*(C(3,:,1:3)+C(5,:,1:3)-2*rho*c(8,:,1:3).^2))-C(5,:,1:3);
C(9,:,1:3)=sqrt((C(2,:,1:3)+C(4,:,1:3)-2*rho*c(9,:,1:3).^2).*(C(3,:,1:3)+C(4,:,1:3)-2*rho*c(9,:,1:3).^2))-C(4,:,1:3);


